"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFtpConfig = exports.config = void 0;
const http_1 = __importDefault(require("http"));
const fs_1 = __importDefault(require("fs"));
exports.config = (ctx) => {
    let userConfig = ctx.getConfig('picBed.ftp-uploader');
    if (!userConfig) {
        userConfig = {
            site: '',
            configFile: ''
        };
    }
    return [
        {
            name: 'site',
            type: 'input',
            default: userConfig.site,
            required: true,
            message: 'imba97',
            alias: '网站标识'
        },
        {
            name: 'configFile',
            type: 'input',
            default: userConfig.configFile,
            required: true,
            message: 'C:/ftpUploaderConfig.json',
            alias: '配置文件'
        }
    ];
};
exports.getFtpConfig = (userConfig) => {
    return new Promise((resolve, reject) => {
        // 如果是网址 则用 http 否则是本地 用 fs
        if (/^http/.test(userConfig.configFile)) {
            // 网络
            http_1.default
                .get(userConfig.configFile, (res) => {
                if (res.statusCode !== 200) {
                    reject(res.statusCode);
                    res.resume();
                    return;
                }
                res.setEncoding('utf8');
                let body = '';
                res.on('data', (chunk) => {
                    body += chunk;
                });
                res.on('end', () => {
                    resolve(JSON.parse(body));
                });
            })
                .on('error', (e) => {
                reject(e.message);
            });
        }
        else {
            // 本地
            resolve(JSON.parse(fs_1.default.readFileSync(userConfig.configFile).toString()));
        }
    });
};
